<?php

namespace Qii\Driver\mysql;

class Connection extends \Qii\Driver\ConnBase implements \Qii\Driver\ConnIntf
{
    const VERSION = '1.2';
    protected $_dbInfo;

    /**
     * @var resource $_writeConnection  获取写的链接
     */
    protected static $_writeConnection = null;
    /**
     * @var resource$_readConnection 获取读的链接
     */
    protected static $_readConnection = null;

    public function __construct()
    {
        $this->_dbInfo = \Qii\Config\Register::getAppConfigure(\Qii\Config\Register::get(\Qii\Config\Consts::APP_DB));
    }

    /**
     * 获取读数据的连接资源
     */
    public function getReadConnection()
    {
        if (self::$_readConnection != null) {
            return self::$_readConnection;
        }
        $dbInfo = $this->_dbInfo['master'];
        $useSlave = false;

        if ($this->_dbInfo['readOrWriteSeparation'] && $this->_dbInfo['slave']) {
            $i = rand(0, count($this->_dbInfo['slave']) - 1);
            $dbInfo = $this->_dbInfo['slave'][$i];
            $useSlave = true;
        }

        if ($useSlave) {
            try {
                $connection = mysql_connect($dbInfo['host'], $dbInfo['user'], $dbInfo['password'], $dbInfo['db']);
                if (!$connection) throw new \Qii\Exceptions\Errors(\Qii::i(1501, iconv("GBK", "UTF-8//TRANSLIT", mysql_error())), true);
                return self::$_readConnection = $connection;
            } catch (Exception  $e) {
                return $this->getWriteConnection();
            }
        }
        return $this->getWriteConnection();
    }

    /**
     * 获取写数据的连接资源
     *
     */
    public function getWriteConnection()
    {
        if (self::$_writeConnection != null) {
            return self::$_writeConnection;
        }
        $dbInfo = $this->_dbInfo['master'];
        try {
            $connection = mysql_connect($dbInfo['host'], $dbInfo['user'], $dbInfo['password'], $dbInfo['db']);
            if (!$connection) throw new \Qii\Exceptions\Errors(\Qii::i(1501, iconv("GBK", "UTF-8//TRANSLIT", mysql_error())), true);
            return self::$_writeConnection = $connection;
        } catch (Exception  $e) {
            throw new \Qii\Exceptions\Errors(\Qii::i(1500, $dbInfo['host'], $dbInfo['user'], $dbInfo['password'], $dbInfo['db'], toUTF8($e->getMessage())));
        }
    }
}